#pragma once
#include <stdlib.h>
#include <stdio.h>
#include <vector>
#include "pos.h"

const int SECTORSIZE = 200000; // 100000 in all directions

enum NavCompare
{
	NAVPOS=1,
	NAVSECTOR=2,
	NAVTYPE=4,
	NAVNAME=8,
	NAVVALUE=16,
	NAVPARENT=32,
	NAVID=64,
	NAVRANGE=128,
	NAVTRILAT=256
};

class NavEntry
{
	public:
		int id; // position in vector
		NavEntry* parent;	
		int lngParent;
		Pos* navPos;
		Pos* sectPos;
		char* type; // entry type
		char* name; // entry display name
		char* value; // value of entry
		_int64 recorded; // date entry made
		_int64 visited; // date last visited
		bool expanded;
		NavEntry();
		NavEntry(NavEntry& navSource);
		bool Equals(NavEntry* navCompare, unsigned int intComparison);
		double RangeTo(NavEntry* inTarget);
		void SetNavPos(Pos* inPos);
		void SetSectPos(Pos* inPos);
		void SetData(Pos* inNav, Pos* inSect, char* inType, char* inName, char* inValue);
		void SetName(char* inName);
		bool SetPosition(char* inPosition);
		void SetType(char* inType);
		void SetValue(char* inValue);	
		void SetParent(NavEntry* inParent);
		~NavEntry();
};